*株式会社ライトストーン
*Stata分析機能例題集　Lasso

************選択(cv):クロスバリデーション************

*データセットをインポート
sysuse auto

*乱数キーを設定
set seed 1234

*モデルを推定
lasso linear mpg i.foreign i.rep78 headroom weight turn gear_ratio price trunk length displacement

*推定結果を保存
estimates store autolasso

*各λに対して係数を推定
lassoknots, alllambdas
lassoknots


************CV（クロスバリデーション）関数************

*CV関数をプロット
cvplot

*CV関数の値をもっと表示
set seed 1234
lasso linear mpg i.foreign i.rep78 headroom weight turn gear_ratio price trunk length displacement, selection(cv, alllambdas)

*λに対してCV関数をプロット
cvplot

*λの最小値を調べる
lasso linear mpg i.foreign i.rep78 headroom weight turn gear_ratio price trunk length displacement, selection(cv, alllambdas) stop(0)


************係数へのペナルティと選択************

*標準化した変数による係数
lassocoef, display(coef, standardized)

*標準化なし
lassocoef, display(coef, penalized)

*選択した変数を利用して線形回帰を実行し、その係数を利用
lassocoef, display(coef, postselection)

*regressコマンドを使って結果を再現
regress mpg 0bn.foreign 3bn.rep78 5bn.rep78 weight turn gear_ratio price length


***lassoselectコマンドを使って手作業でλを選択する***

*lassoの結果をメモリー上に保存
estimates store lasso2

*結果をファイルとして保存
estimates save testlasso

*保存結果を呼び出す
estimates restore autolasso

*2種類のR^2を表示
lassoknots, display(cvmpe r2 osr2)

*ID=15のλを使用
lassoselect id = 15

*CV関数をプロット
cvplot

*係数を表示し、先の結果と比べる
lassocoef autolasso ., display(coef, postselection)
